%% Run super-twisting algorithm with HOSMO to estimate x_2

% Model parameter values

m = 2; % Kg
c = 5; % N/ms*2
k = 2; % N/m

% Observer gains
L = 16;
k_1 = 6*L^(1/3);
k_2 = 11*L^(1/2);
k_3 = 6*L;

% Sliding surface
c_1 = 1;

% Control gains
K = 75; 

sim('MSDS_STA_HOSMO_est_x_2');

%% Plot

figure(1)
subplot(3,1,1);
plot(x_1_des.time,x_1_des.signals.values,'r','LineSmoothing','on')
hold on
plot(x_1.time,x_1.signals.values,'b','LineSmoothing','on')
title('X_{des} with X'); xlabel('Time [s]');ylabel('Position of mass [m]');
legend('x_{des}','x');
xlim([0 50])

subplot(3,1,2);
plot(disturbance.time,disturbance.signals.values,'b','LineSmoothing','on')
title('Disturbance'); xlabel('Time [s]');ylabel('Force [N]');
xlim([0 50])

subplot(3,1,3);
plot(control_input.time,control_input.signals.values,'b','LineSmoothing','on')
title('Control input u'); xlabel('Time [s]');ylabel('Force [N]');
xlim([0 50])

figure(2)
subplot(4,1,1);
plot(sliding_var.time,sliding_var.signals.values,'b','LineSmoothing','on')
title('Sliding variable \sigma'); xlabel('Time [s]');
xlim([0 50])

subplot(4,1,2);
plot(x_1.time,x_1.signals.values-x_1_des.signals.values,'b','LineSmoothing','on')
title('Position error'); xlabel('Time [s]');ylabel('[m]');
xlim([0 50])

subplot(4,1,3);
plot(e_1.time,e_1.signals.values,'b','LineSmoothing','on')
title('Observer error e_1'); xlabel('Time [s]');ylabel('[m]');
xlim([0 50])

subplot(4,1,4);
plot(e_2.time,e_2.signals.values,'b','LineSmoothing','on')
title('Observer error e_2'); xlabel('Time [s]');ylabel('[m/s]');
xlim([0 50])