%% Run super-twisting algorithm 

% Model parameter values

m = 2; % Kg
c = 5; % N/ms*2
k = 2; % N/m

% Sliding surface
c_1 = 1;

% Control gains
K = 100; 

sim('MSDS_STA');

%% Plot

figure(1)
subplot(5,1,1);
plot(x_1_des.time,x_1_des.signals.values,'r','LineSmoothing','on')
hold on
plot(x_1.time,x_1.signals.values,'b','LineSmoothing','on')
title('X_{des} with X'); xlabel('Time [s]');ylabel('Position of mass [m]');
legend('x_{des}','x');
xlim([0 50])

subplot(5,1,2);
plot(disturbance.time,disturbance.signals.values,'b','LineSmoothing','on')
title('Disturbance'); xlabel('Time [s]');ylabel('Force [N]');
xlim([0 50])

subplot(5,1,3);
plot(control_input.time,control_input.signals.values,'b','LineSmoothing','on')
title('Control input u'); xlabel('Time [s]');ylabel('Force [N]');
xlim([0 50])

subplot(5,1,4);
plot(sliding_var.time,sliding_var.signals.values,'b','LineSmoothing','on')
title('Sliding variable \sigma'); xlabel('Time [s]');
xlim([0 50])

subplot(5,1,5);
plot(x_1.time,x_1.signals.values-x_1_des.signals.values,'b','LineSmoothing','on')
title('Position error'); xlabel('Time [s]');ylabel('[m]');
xlim([0 50])
