function [b_X, b_Y, B_X, B_Y] = calculate_thruster_config_matrices_3DOF(link_number, thruster_axis_configuration, theta, n)

thruster_count = length(link_number);

b_X = zeros(thruster_count,1);
b_Y = zeros(thruster_count,1);
B_X = zeros(thruster_count, n);
B_Y = zeros(thruster_count, n);

for i = 1:thruster_count
    if thruster_axis_configuration(i) == 'X'
        b_X(i,1) = cos(theta(link_number(i)));
        b_Y(i,1) = sin(theta(link_number(i)));        
    elseif thruster_axis_configuration(i) == 'Y'
        b_X(i,1) = -sin(theta(link_number(i)));
        b_Y(i,1) = cos(theta(link_number(i)));
    end
    B_X(i,link_number(i)) = b_X(i,1);
    B_Y(i,link_number(i)) = b_Y(i,1);
end