function [f_thr] = calculate_thruster_forces(tau_d, T, W_inv)
% Calculates and returns the thruster forces
% T - allocation matrix
% W - thruster weighting matrix


% Calculate weighted inverse of allocation matrix
% T_dagger = pinv(T);   % using pinv() in the beginning since W is the identity matrix (equal weighting)
T_dagger = W_inv*T'/(T*W_inv*T');

% r = rcond(T_dagger);
% if r < 0.01
%     r
%     T_dagger
%     pause
% end

% Calculate thruster forces
% Assumption: Neglecting the dynamics of the thrusters. The thrusters
% immediately produces the commanded force

f_thr = T_dagger*tau_d;

end