%% Plot for STA when state observer is used

figure(1)
subplot(3,1,1);
plot(t_sim,p_CM_d_sim(:,1),'r', 'LineSmoothing','on')
hold on
plot(t_sim,px_sim,'b', 'LineSmoothing','on') 
title('x_{des} with x');xlabel('Time [s]');ylabel('p_x [m]');
legend('x_{des}','x');

subplot(3,1,2);
plot(t_sim,p_CM_d_sim(:,2),'r', 'LineSmoothing','on')
hold on
plot(t_sim,py_sim,'b', 'LineSmoothing','on') 
title('y_{des} with y');xlabel('Time [s]');ylabel('p_y [m]');
legend('y_{des}','y');

subplot(3,1,3);
plot(t_sim,F_CM_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,F_CM_sim(:,2),'r', 'LineSmoothing','on')
title('Control input u');xlabel('Time [s]');ylabel('Force [N]');
legend('x','y');

figure(2)
subplot(4,1,1);
plot(t_sim,sigma_f_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,sigma_f_sim(:,2),'r', 'LineSmoothing','on')
title('Sliding variable \sigma');xlabel('Time [s]');
legend('x','y');

subplot(4,1,2);
plot(t_sim,error_pos_CM_sim(:,1),'b', 'LineSmoothing','on')
hold on 
plot(t_sim,error_pos_CM_sim(:,2),'r', 'LineSmoothing','on')
title('Position error');xlabel('Time [s]');ylabel('[m]');
legend('x','y');

subplot(4,1,3);
plot(t_sim,observer_error_e_1_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,observer_error_e_1_sim(:,2),'r', 'LineSmoothing','on')
title('Observer error e_1');xlabel('Time [s]');ylabel('[m]');
legend('x','y');

subplot(4,1,4);
plot(t_sim,observer_error_e_2_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,observer_error_e_2_sim(:,2),'r', 'LineSmoothing','on')
title('Observer error e_2'); xlabel('Time [s]');ylabel('[m/s]');
legend('x','y');

%% Plot for STA when state observer is not used

figure(1)
subplot(5,1,1);
plot(t_sim,p_CM_d_sim(:,1),'r', 'LineSmoothing','on')
hold on
plot(t_sim,px_sim,'b', 'LineSmoothing','on') 
title('x_{des} with x');xlabel('Time [s]');ylabel('p_x [m]');
legend('x_{des}','x');

subplot(5,1,2);
plot(t_sim,p_CM_d_sim(:,2),'r', 'LineSmoothing','on')
hold on
plot(t_sim,py_sim,'b', 'LineSmoothing','on') 
title('y_{des} with y');xlabel('Time [s]');ylabel('p_y [m]');
legend('y_{des}','y');

subplot(5,1,3);
plot(t_sim,F_CM_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,F_CM_sim(:,2),'r', 'LineSmoothing','on')
title('Control input u');xlabel('Time [s]');ylabel('Force [N]');
legend('x','y');

subplot(5,1,4);
plot(t_sim,sigma_f_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,sigma_f_sim(:,2),'r', 'LineSmoothing','on')
title('Sliding variable \sigma');xlabel('Time [s]');
legend('x','y');

subplot(5,1,5);
plot(t_sim,error_pos_CM_sim(:,1),'b', 'LineSmoothing','on')
hold on 
plot(t_sim,error_pos_CM_sim(:,2),'r', 'LineSmoothing','on')
title('Position error');xlabel('Time [s]');ylabel('[m]');
legend('x','y');


%% Plot for third-order algorithm when state observer is used

figure(1)
subplot(4,1,1);
plot(t_sim,p_CM_d_sim(:,1),'r', 'LineSmoothing','on')
hold on
plot(t_sim,px_sim,'b', 'LineSmoothing','on') 
title('x_{des} with x');xlabel('Time [s]');ylabel('p_x [m]');
legend('x_{des}','x');

subplot(4,1,2);
plot(t_sim,p_CM_d_sim(:,2),'r', 'LineSmoothing','on')
hold on
plot(t_sim,py_sim,'b', 'LineSmoothing','on') 
title('y_{des} with y');xlabel('Time [s]');ylabel('p_y [m]');
legend('y_{des}','y');

subplot(4,1,3);
plot(t_sim,F_CM_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,F_CM_sim(:,2),'r', 'LineSmoothing','on')
title('Control input u');xlabel('Time [s]');ylabel('Force [N]');
legend('x','y');

subplot(4,1,4);
plot(t_sim,sigma_f_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,sigma_f_sim(:,2),'r', 'LineSmoothing','on')
title('Sliding variable \sigma');xlabel('Time [s]');
legend('x','y');

figure(2)
subplot(5,1,1);
plot(t_sim,error_pos_CM_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,error_pos_CM_sim(:,2),'r', 'LineSmoothing','on')
title('Position error');xlabel('Time [s]');ylabel('[m]');
legend('x','y');

subplot(5,1,2);
plot(t_sim,observer_error_e_1_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,observer_error_e_1_sim(:,2),'r', 'LineSmoothing','on')
title('Observer error e_1');xlabel('Time [s]');ylabel('[m]');
legend('x','y');

subplot(5,1,3);
plot(t_sim,observer_error_e_2_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,observer_error_e_2_sim(:,2),'r', 'LineSmoothing','on')
title('Observer error e_2'); xlabel('Time [s]');ylabel('[m/s]');
legend('x','y');

subplot(5,1,4);
plot(t_sim,differentiator_error(:,1),'r', 'LineSmoothing','on')
hold on
plot(t_sim,differentiator_error(:,3),'b', 'LineSmoothing','on')
hold on
plot(t_sim,differentiator_error(:,5),'g', 'LineSmoothing','on')
title('Differentiator error z_0, z_1 and z_2 for x'); xlabel('Time [s]');
legend('z_0','z_1','z_2');

subplot(5,1,5);
plot(t_sim,differentiator_error(:,2),'r', 'LineSmoothing','on')
hold on
plot(t_sim,differentiator_error(:,4),'b', 'LineSmoothing','on')
hold on
plot(t_sim,differentiator_error(:,6),'g', 'LineSmoothing','on')
title('Differentiator error z_0, z_1 and z_2 for y'); xlabel('Time [s]');
legend('z_0','z_1','z_2');

%% Plot for third-order algorithm when state observer is not used

figure(1)
subplot(3,1,1);
plot(t_sim,p_CM_d_sim(:,1),'r', 'LineSmoothing','on')
hold on
plot(t_sim,px_sim,'b', 'LineSmoothing','on') 
title('x_{des} with x');xlabel('Time [s]');ylabel('p_x [m]');
legend('x_{des}','x');

subplot(3,1,2);
plot(t_sim,p_CM_d_sim(:,2),'r', 'LineSmoothing','on')
hold on
plot(t_sim,py_sim,'b', 'LineSmoothing','on') 
title('y_{des} with y');xlabel('Time [s]');ylabel('p_y [m]');
legend('y_{des}','y');

subplot(3,1,3);
plot(t_sim,F_CM_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,F_CM_sim(:,2),'r', 'LineSmoothing','on')
title('Control input u');xlabel('Time [s]');ylabel('Force [N]');
legend('x','y');

figure(2)
subplot(4,1,1);
plot(t_sim,sigma_f_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,sigma_f_sim(:,2),'r', 'LineSmoothing','on')
title('Sliding variable \sigma');xlabel('Time [s]');
legend('x','y');

subplot(4,1,2);
plot(t_sim,error_pos_CM_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,error_pos_CM_sim(:,2),'r', 'LineSmoothing','on')
title('Position error');xlabel('Time [s]');ylabel('[m]');
legend('x','y');

subplot(4,1,3);
plot(t_sim,differentiator_error(:,1),'r', 'LineSmoothing','on')
hold on
plot(t_sim,differentiator_error(:,3),'b', 'LineSmoothing','on')
hold on
plot(t_sim,differentiator_error(:,5),'g', 'LineSmoothing','on')
title('Differentiator error z_0, z_1 and z_2 for x'); xlabel('Time [s]');
legend('z_0','z_1','z_2');

subplot(4,1,4);
plot(t_sim,differentiator_error(:,2),'r', 'LineSmoothing','on')
hold on
plot(t_sim,differentiator_error(:,4),'b', 'LineSmoothing','on')
hold on
plot(t_sim,differentiator_error(:,6),'g', 'LineSmoothing','on')
title('Differentiator error z_0, z_1 and z_2 for y'); xlabel('Time [s]');
legend('z_0','z_1','z_2');

%% Plot for PD-controller when estimated values are used

figure(1)
subplot(3,1,1);
plot(t_sim,p_CM_d_sim(:,1),'r', 'LineSmoothing','on')
hold on
plot(t_sim,px_sim,'b', 'LineSmoothing','on') 
title('x_{des} with x');ylabel('p_x [m]');
legend('x_{des}','x');

subplot(3,1,2);
plot(t_sim,p_CM_d_sim(:,2),'r', 'LineSmoothing','on')
hold on
plot(t_sim,py_sim,'b', 'LineSmoothing','on') 
title('y_{des} with y');ylabel('p_y [m]');
legend('y_{des}','y');

subplot(3,1,3);
plot(t_sim,F_CM_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,F_CM_sim(:,2),'r', 'LineSmoothing','on')
title('Control input u');ylabel('Force [N]');
legend('x','y');

figure(2)
subplot(3,1,1);
plot(t_sim,error_pos_CM_sim(:,1),'b', 'LineSmoothing','on')
hold on 
plot(t_sim,error_pos_CM_sim(:,2),'r', 'LineSmoothing','on')
title('Position error');xlabel('Time [s]');ylabel('[m]');
legend('x','y');

subplot(3,1,2);
plot(t_sim,observer_error_e_1_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,observer_error_e_1_sim(:,2),'r', 'LineSmoothing','on')
title('Observer error e_1');xlabel('Time [s]');ylabel('[m]');
legend('x','y');

subplot(3,1,3);
plot(t_sim,observer_error_e_2_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,observer_error_e_2_sim(:,2),'r', 'LineSmoothing','on')
title('Observer error e_2'); xlabel('Time [s]');ylabel('[m/s]');
legend('x','y');

%% Plot for PD-controller when estimated values are not used

figure(1)
subplot(4,1,1);
plot(t_sim,p_CM_d_sim(:,1),'r', 'LineSmoothing','on')
hold on
plot(t_sim,px_sim,'b', 'LineSmoothing','on') 
title('x_{des} with x');ylabel('p_x [m]');
legend('x_{des}','x');

subplot(4,1,2);
plot(t_sim,p_CM_d_sim(:,2),'r', 'LineSmoothing','on')
hold on
plot(t_sim,py_sim,'b', 'LineSmoothing','on') 
title('y_{des} with y');ylabel('p_y [m]');
legend('y_{des}','y');

subplot(4,1,3);
plot(t_sim,F_CM_sim(:,1),'b', 'LineSmoothing','on')
hold on
plot(t_sim,F_CM_sim(:,2),'r', 'LineSmoothing','on')
title('Control input u');ylabel('Force [N]');
legend('x','y');

subplot(4,1,4);
plot(t_sim,error_pos_CM_sim(:,1),'b', 'LineSmoothing','on')
hold on 
plot(t_sim,error_pos_CM_sim(:,2),'r', 'LineSmoothing','on')
title('Position error');xlabel('Time [s]');ylabel('[m]');
legend('x','y');
